#!/bin/bash
# Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.

set -e

# Time marker for both stderr and stdout
date; date 1>&2

if [ -z "$FLUME_AGENT_NAME" ]; then
  echo "FLUME_AGENT_NAME not set"
  exit 1
fi
if [ -z "$CDH_FLUME_HOME" ]; then
  echo "CDH_FLUME_HOME not set"
  exit 1
fi

CDH_FLUME_BIN=$CDH_FLUME_HOME/bin/flume-ng
echo "using agent name $FLUME_AGENT_NAME"
echo "using Flume executable $CDH_FLUME_BIN"

set -x

# If flume agent is writing to a secure HDFS, the config file
# will contain the location of the keytab as {{CMF_CONF_DIR}}/flume.keytab.
# Replace it with the actual config dir.
perl -pi -e "s#{{CMF_CONF_DIR}}#$CONF_DIR#g" $CONF_DIR/flume.conf

FLUME_CONF_FILE=${CONF_DIR}/flume.conf
cloudera_config=`dirname $0`
cloudera_config=`cd "$cloudera_config/../common"; pwd`
. ${cloudera_config}/cloudera-config.sh

locate_java_home

set_flume_classpath

# The standard Flume script observes FLUME_CLASSPATH.
exec $CDH_FLUME_BIN agent \
  --conf $CONF_DIR --conf-file $FLUME_CONF_FILE --name $FLUME_AGENT_NAME $FLUME_AGENT_JAVA_OPTS
