// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
	"cloudera/chart/TimeRange",
	"cloudera/chart/ServiceChartSet",
	"cloudera/chart/ChartUtil"
], function(TimeRange, ServiceChartSet, ChartUtil) {

/**
 * This represents one or more service charts on the service/role status page.
 */
return ServiceChartSet.extend({

	// TODO:
	// make the constant here a common constants else where.
	_broadcastRangeChange: function() {
		jQuery.publish("chartRangeChanged", [new TimeRange(this.firstVisibleDate, this.lastVisibleDate)]);
	},

	initializeTime: function() {
		this._super.apply(this, arguments);
		var self = this;

		var updateSelectedRange = function(range, isCurrentMode){
			ChartUtil.updateOnTimeSelectionChange(self, range, isCurrentMode);
		};
		this.subscriptionHandle = jQuery.subscribe("timeSelectionChanged", updateSelectedRange);
	},

	onChartDraw: function() {
		this._super.apply(this, arguments);
		this.zoomTo(this.firstVisibleDate, this.lastVisibleDate);
		ChartUtil.resize(this, this.options.chartWidth, this.options.chartHeight);
	},

	unsubscribe: function() {
		if (this.subscriptionHandle) {
			jQuery.unsubscribe(this.subscriptionHandle);
		}
	}
});

});
