// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
	"cloudera/layout/AjaxLink",
	// we use MegaBase to associate elements with class AjaxLink
	// to AjaxLink.
	"cloudera/MegaBase"
], function(AjaxLink, MegaBase) {

	describe("AjaxLink Tests", function() {
		var someButton = '<a id="someButton" data-method="post" class="AjaxLink" href="/dontcare">Ajax Button</a>';

		beforeEach(function() {
			jasmine.Ajax.useMock();
			clearAjaxRequests();

			$(someButton).appendTo("body");
		});

		afterEach(function() {
			$("#someButton").remove();
		});

		it("should process a response via AJAX.", function() {
			$("#someButton").trigger("click");

			var request = mostRecentAjaxRequest();
			request.response({
				status: 200,
				contentType: "text/html",
				responseText: '<div id="bar" class="modal"></div>'
			});

			expect($("#bar").length > 0).toBeTruthy();
			$("#bar").remove();
		});

		it("should block a response via AJAX when a dialog with the same id exists.", function() {
			var $existingDialog = $('<div id="bar" class="modal in"></div>');
			$existingDialog.appendTo("body");

			$("#someButton").trigger("click");

			var request = mostRecentAjaxRequest();
			request.response({
				status: 200,
				contentType: "text/html",
				responseText: '<div id="bar"><div id="barContent"></div></div>'
			});

			// Don't expect the new content to be added because
			// an existing dialog is shown.
			expect($("#barContent").length === 0).toBeTruthy();

			$existingDialog.remove();
		});

	});
});
